%module pecco
%{
#include "typedef.h"
#include "timer.h"
#include "polyk.h"
%}

#ifdef SWIGPERL
%typemap (in) (std::vector <unsigned int> &) (std::vector <unsigned int> vec) {
  if (! SvROK ($input) or SvTYPE (SvRV ($input)) != SVt_PVAV)
    croak ("not a list");
  int len = av_len (reinterpret_cast <AV *> (SvRV ($input))) + 1;
  vec.reserve (len);
  for (int i = 0; i < len; ++i) {
    SV **po = av_fetch (reinterpret_cast <AV *> (SvRV ($input)), i, 0);
    if (! SvUOK (*po))
      croak ("not an integer");
    vec.push_back (SvUV (*po));
  }
  $1 = &vec;
}
#endif

#ifdef SWIGPYTHON
%typemap (in) (std::vector <unsigned int> &) (std::vector <unsigned int> vec) {
  if (! PyList_Check ($input))
    { PyErr_SetString (PyExc_TypeError, "not a list"); return NULL; }
  int len = PyList_Size ($input);
  vec.reserve (len);
  for (int i = 0; i < len; ++i) {
    PyObject *po = PyList_GetItem ($input, i);
    if (! PyInt_Check (po))
      { PyErr_SetString (PyExc_TypeError, "not an integer"); return NULL; }
    vec.push_back (PyInt_AsLong (po));
  }
  $1 = &vec;
}
#endif

#ifdef SWIGRUBY
%typemap (in) (std::vector <unsigned int> &) (std::vector <unsigned int> vec) {
  Check_Type ($input, T_ARRAY);
  int len = RARRAY_LEN ($input);
  vec.reserve (len);
  for (int i = 0; i < len; ++i) {
    VALUE ro = rb_ary_entry ($input, i);
    Check_Type (ro, T_FIXNUM);
    vec.push_back (FIX2UINT (ro));
  }
  $1 = &vec;
}
#endif

#ifdef SWIGLUA
%typemap (in) (std::vector <unsigned int> &) (std::vector <unsigned int> vec) {
  if (! lua_istable (L, $input)) return 0;
  int i = 0;
  while (1) {
    lua_rawgeti (L, $input, i+1);
    if (lua_isnil (L, -1)) {
      lua_pop (L, 1);
      break;
    }
    if (! lua_isnumber (L, -1)) {
      lua_pop (L, 1);
      return 0;
    }
    vec.push_back (static_cast <unsigned int> (lua_tonumber (L, -1)));
    lua_pop (L, 1);
    ++i;
  }
  $1 = &vec;
}
#endif

%include "typedef.h"
%include "timer.h"
%include "polyk.h"
